//package com.galaxis.wms.filter;
//
//import com.galaxis.wms.GlobalConstant;
//import lombok.extern.slf4j.Slf4j;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.cloud.gateway.filter.GatewayFilter;
//import org.springframework.cloud.gateway.filter.GatewayFilterChain;
//import org.springframework.cloud.gateway.filter.GlobalFilter;
//import org.springframework.cloud.gateway.filter.NettyWriteResponseFilter;
//import org.springframework.cloud.gateway.filter.factory.rewrite.ModifyResponseBodyGatewayFilterFactory;
//import org.springframework.core.Ordered;
//import org.springframework.stereotype.Component;
//import org.springframework.web.server.ServerWebExchange;
//import reactor.core.publisher.Mono;
//
///**
// * 作者：lizw <br/>
// * 创建时间：2021/04/29 09:25 <br/>
// */
//@Component
//@Slf4j
//public class CacheResponseBodyGlobalFilter implements GlobalFilter, Ordered {
//    private static final int ORDER = NettyWriteResponseFilter.WRITE_RESPONSE_FILTER_ORDER - 2;
//    private static final int RESPONSE_BODY_MAX_LENGTH = 2047;
//
//    @Autowired
//    private ModifyResponseBodyGatewayFilterFactory modifyResponseBodyGatewayFilterFactory;
//
//    @Override
//    public Mono<Void> filter(ServerWebExchange exchange, GatewayFilterChain chain) {
//        final StringBuilder responseBody = new StringBuilder(RESPONSE_BODY_MAX_LENGTH);
//        exchange.getAttributes().put(GlobalConstant.GATEWAY_RESPONSE_BODY_ATTR, responseBody);
//        ModifyResponseBodyGatewayFilterFactory.Config config = new ModifyResponseBodyGatewayFilterFactory.Config()
//                .setRewriteFunction(
//                        String.class,
//                        String.class,
//                        (serverWebExchange, body) -> {
//                            if (responseBody.length() < RESPONSE_BODY_MAX_LENGTH) {
//                                responseBody.append(body);
//                                if (responseBody.length() > RESPONSE_BODY_MAX_LENGTH) {
//                                    responseBody.delete(RESPONSE_BODY_MAX_LENGTH, responseBody.length());
//                                }
//                            }
//                            return Mono.just(body);
//                        }
//                );
//        GatewayFilter delegate = modifyResponseBodyGatewayFilterFactory.apply(config);
//        return delegate.filter(exchange, chain);
//    }
//
//    @Override
//    public int getOrder() {
//        return ORDER;
//    }
//}
